#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>


#define MAX_REQUEST_SIZE (32 * 1024)

void handle_connection(int connection, char* remoteAddress, uint16_t remotePort)
{
    printf("Incoming connection from %s:%u...\n", remoteAddress, remotePort);
    // make space for the request
    char *buffer = (char *)malloc(MAX_REQUEST_SIZE);
    // read in the data, keep space for 0-byte
    size_t nRead = read(connection, buffer, MAX_REQUEST_SIZE - 1);
    // we interpret the data as string, need to bound with 0-byte
    buffer[nRead] = 0;
    // push readPtr along, so we can find successive spaces
    char *next = buffer;
    
    while (*next)
    {
        // find space in buffer
        char *space = strchr(next, ' ');
        if (!space) break;
        // bound the string
        *space = 0;
        // find the first occurence of ':' (if it exists)
        char *T = strchr(next, ':');
        // strchr returns a NULLptr if it couldn't find the character. Check before dereferencing!!
        if (T)
        {
            // end the string at ':'
            // so our buffer holds two strings
            // +--------+--------+
            // | part 1 | part 2 |
            // +--------+--------+
            *T = 0;
            // dprintf sends something back to the client
            dprintf(connection, "Hello %s, you entered %s\r\n", next, T + 1);
        }
        else
        {
            // no ':', so return error message
            dprintf(connection, "No ':' found, please try again\r\n");
        }
        next = space + 1;
    }
    
    free(buffer);
    close(connection);
}
